winstd::bstr Class Reference
COM object management

BSTR string wrapper. More...

`#include <WinStd/COM.h>`

Inheritance diagram for winstd::bstr:

## Public Member Functions

| bstr (LPCOLESTR src) noexcept
| Constructs BSTR from OLE string.
| bstr (LPCOLESTR src, UINT len) noexcept
| Constructs BSTR from OLE string with length.
template<class _Traits , class _Ax >
| bstr (const std::basic_string< wchar_t, _Traits, _Ax > &src) noexcept
| Constructs BSTR from std::basic_string.
virtual | ~bstr ()
| Destroys the string. More...
UINT | length () const noexcept
| Returns the length of the string. More...
Public Member Functions inherited from winstd::dplhandle< BSTR, NULL >
| dplhandle () noexcept
| Initializes a new class instance with the object handle set to INVAL.
| dplhandle (handle_type h) noexcept
| Initializes a new class instance with an already available object handle. More...
| dplhandle (const dplhandle< handle_type, INVAL > &h) noexcept
| Copy constructor. More...
| dplhandle (dplhandle< handle_type, INVAL > &&h) noexcept
| Move constructor. More...
dplhandle< handle_type, INVAL > & | operator= (handle_type h) noexcept
| Attaches already available object handle. More...
dplhandle< handle_type, INVAL > & | operator= (const dplhandle< handle_type, INVAL > &h) noexcept
| Duplicates the object. More...
dplhandle< handle_type, INVAL > & | operator= (dplhandle< handle_type, INVAL > &&h) noexcept
| Moves the object. More...
handle_type | duplicate () const
| Duplicates and returns a new object handle. More...
bool | attach_duplicated (handle_type h)
| Duplicates an object handle and sets a new object handle. More...
Public Member Functions inherited from winstd::handle< BSTR, INVAL >
| handle () noexcept
| Initializes a new class instance with the object handle set to INVAL.
| handle (handle_type h) noexcept
| Initializes a new class instance with an already available object handle. More...
| handle (handle< handle_type, INVAL > &&h) noexcept
| Move constructor. More...
handle< handle_type, INVAL > & | operator= (handle_type h) noexcept
| Attaches already available object handle. More...
handle< handle_type, INVAL > & | operator= (handle< handle_type, INVAL > &&h) noexcept
| Move assignment. More...
| operator handle_type () const
| Auto-typecasting operator. More...
handle_type *& | operator* () const
| Returns the object handle value when the object handle is a pointer to a value (class, struct, etc.). More...
handle_type * | operator& ()
| Returns the object handle reference. More...
handle_type | operator-> () const
| Provides object handle member access when the object handle is a pointer to a class or struct. More...
bool | operator! () const
| Tests if the object handle is INVAL. More...
bool | operator< (handle_type h) const
| Is handle less than? More...
bool | operator<= (handle_type h) const
| Is handle less than or equal to? More...
bool | operator>= (handle_type h) const
| Is handle greater than or equal to? More...
bool | operator> (handle_type h) const
| Is handle greater than? More...
bool | operator!= (handle_type h) const
| Is handle not equal to? More...
bool | operator== (handle_type h) const
| Is handle equal to? More...
void | attach (handle_type h) noexcept
| Sets a new object handle for the class. More...
handle_type | detach ()
| Dismisses the object handle from this class. More...
void | free ()
| Destroys the object.

## Protected Member Functions

void | free_internal () noexcept override
| Destroys the string. More...
handle_type | duplicate_internal (handle_type h) const noexcept override
| Duplicates the string. More...
virtual handle_type | duplicate_internal (handle_type h) const noexcept=0
| Abstract member function that must be implemented by child classes to do the actual object handle duplication. More...
virtual void | free_internal () noexcept=0
| Abstract member function that must be implemented by child classes to do the actual object destruction. More...

## Additional Inherited Members

Public Types inherited from winstd::handle< BSTR, INVAL >
typedef BSTR | handle_type
| Datatype of the object handle this template class handles.
Static Public Attributes inherited from winstd::handle< BSTR, INVAL >
static const BSTR | invalid
| Invalid handle value.
Protected Attributes inherited from winstd::handle< BSTR, INVAL >
handle_type | m_h
| Object handle.

## Detailed Description

BSTR string wrapper.

## Constructor & Destructor Documentation

## ~bstr()

virtual winstd::bstr::~bstr | ( |  | ) |

inlinevirtual

Destroys the string.

See also
  SysFreeString function

## Member Function Documentation

## duplicate_internal()

handle_type winstd::bstr::duplicate_internal | ( | handle_type | h | ) | const

inlineoverrideprotectedvirtualnoexcept

Duplicates the string.

Parameters

  [in] | h | Existing string

Returns
  Duplicated string

See also
  SysAllocString function

Implements winstd::dplhandle< BSTR, NULL >.

## free_internal()

void winstd::bstr::free_internal | ( |  | ) |

inlineoverrideprotectedvirtualnoexcept

Destroys the string.

See also
  SysFreeString function

Implements winstd::handle< BSTR, INVAL >.

## length()

UINT winstd::bstr::length | ( |  | ) | const

inlinenoexcept

Returns the length of the string.

See also
  SysStringLen function

The documentation for this class was generated from the following file:

- include/WinStd/COM.h